#include "smtp.h"

extern smtpi jtin;



char *_smtp_rc_GetString(pool p, char *lcLang,int liID)
   {
   xmlnode loLang,loString,loStrings;

   if ((loStrings=xmlnode_get_tag(jtin->resources,"strings"))==NULL)
      return NULL; 

   if ((loLang=xmlnode_get_tag(loStrings,spools(p, "lang?xml:lang=", lcLang, p)))==NULL)
      return NULL;

   if ((loString=xmlnode_get_tag(loLang,spools(p, "string?id=", smtp_itoa(p,liID), p)))==NULL)
      return pstrdup(p,SMTP_RC_UNKNOWN);
   else
      return pstrdup(p,xmlnode_get_data(loString));
   }

char *smtp_rc_GetString(pool p,char *lcLang,int liID)
   {
   char *lcString, *ptr;
   int liLen=j_strlen(lcLang);
   xmlnode loMap;
   
   lcString=_smtp_rc_GetString(p,lcLang,liID);

   // string for lang/sublang not found, but lang has sublang
   if (lcString==NULL && liLen>2)
      { // try find string by lang
      lcLang[2]='\0';
      lcString=_smtp_rc_GetString(p,lcLang,liID);
      }

   // string for lang not found, try found string for  map language
   if (lcString==NULL)
      {
      if (liLen>2)
         { // try find string by lang/sublang
         lcLang[2]='-';
         if ((loMap=xmlnode_get_tag(jtin->resources,spools(p, "languages/map?xml:lang=", lcLang, p)))!=NULL)
            lcString=_smtp_rc_GetString(p,xmlnode_get_data(loMap),liID);

         lcLang[2]='\0';
         }

      // try find string by lang
      if (lcString==NULL)
         if ((loMap=xmlnode_get_tag(jtin->resources,spools(p, "languages/map?xml:lang=", lcLang, p)))!=NULL)
            lcString=_smtp_rc_GetString(p,xmlnode_get_data(loMap),liID);

      }

   // string for map language not found, try found string for default language
   if (lcString==NULL)
      lcString=_smtp_rc_GetString(p,SMTP_RC_DEFAULT_LANG,liID);

   // string for default language not found, return "Unknown string"
   if (lcString==NULL)
      lcString=pstrdup(p,SMTP_RC_UNKNOWN);


   while ((ptr = strstr(lcString, "\\n")) != NULL)
      {
      *ptr='\r';
      *(ptr+1)='\n';
      }

   return lcString;
   }


int RC_LoadData(pool p)
   {
   // free loaded data
   if (jtin->resources!=NULL)
      {
      smtp_PoolsSettmp(xmlnode_pool(jtin->resources), 1);
      pool_free(xmlnode_pool(jtin->resources));
      }
   else
      {
      // get resources file name and read it
      if ((jtin->res_file=xmlnode_get_tag_data(jtin->config,"core/resources"))==NULL)
         jtin->res_file=pstrdup(p,SMTP_RESOURCE_FILE);
      }

   if ((jtin->resources=xmlnode_file(jtin->res_file))==NULL)
      { // file not exist or any other bug
      log_error(SMTP_ZONE,"Transport cannot load resource file (%s).",jtin->res_file);
      return -1;
      }

   smtp_PoolsReg(2000, xmlnode_pool(jtin->resources));
   smtp_PoolsSettmp(xmlnode_pool(jtin->resources), 0);

   return 0;
   }

