#include "smtp.h"

extern smtpi jtin;


void smtp_roster_enum( char *lcFC, void *luCB,void *luArg)
   {
   xmlnode loFile,loJID;
   pool p;
   char *lcLetter;

   p=pool_new();
   smtp_PoolsReg(1802, p);


   if (lcFC==NULL) // you must walk all items
      {
      for (loFile = xmlnode_get_tag(jtin->roster_files,"file"); loFile != NULL; loFile = xmlnode_get_nextsibling(loFile))
          {
          if (loFile->type!=NTYPE_TAG)
              continue;

          // walk all jid in file
          for (loJID = xmlnode_get_tag(loFile,"item"); loJID != NULL; loJID = xmlnode_get_nextsibling(loJID))
              {
              if (loJID->type!=NTYPE_TAG)
                  continue;

              (*(smtp_roster_enum_cb)luCB)(luArg,xmlnode_get_attrib(loJID,"jid")); // call callback procedure
              }
          }
      }
   else
      {
      if (j_strlen(lcFC)==1 && lcFC[0]<0)
         {
         lcLetter = (char*)pmalloc_x(p, 4,'\0');
         lcLetter[0]=lcFC[0];
         toEscape(lcLetter,(void *)lcLetter,"()<>,;:\"/[]?");
         }
      else
         lcLetter=lcFC;

      if ((loFile=xmlnode_get_tag(jtin->roster_files,spools(p,"file?type=",lcLetter,p)))!=NULL)
         {
         for (loJID = xmlnode_get_tag(loFile,"item"); loJID != NULL; loJID = xmlnode_get_nextsibling(loJID))
             {
             if (loJID->type!=NTYPE_TAG)
                 continue;

             (*(smtp_roster_enum_cb)luCB)(luArg,xmlnode_get_attrib(loJID,"jid")); // call callback procedure
             }
         }
      }


   pool_free(p);
   return;
   }

xmlnode smtp_roster_get_defaultitem(char *lcJID)
   {
   xmlnode loJID, loSubj;
   pool p;
   loJID=xmlnode_new_tag_pool(p=pool_new(), "item");
   smtp_PoolsReg(1800, p);

   xmlnode_put_attrib(loJID,"jid",lcJID);

   // set default values

   xmlnode_put_attrib(loJID,"UseGlobalSettings","0");
   xmlnode_put_attrib(loJID,"paid","0");
   xmlnode_put_attrib(loJID,"Attachments",xmlnode_get_attrib(xmlnode_get_tag(jtin->config,"smtp/attachments"),"pass"));
   xmlnode_put_attrib(loJID,"PGPJabberToMIME",xmlnode_get_attrib(xmlnode_get_tag(jtin->config,"jabber/pgp"),"mime"));
   xmlnode_put_attrib(loJID,"PGPToJabbernonMIMETox",xmlnode_get_attrib(xmlnode_get_tag(jtin->config,"smtp/pgp"), "nonmime2x"));
   xmlnode_put_attrib(loJID,"S2J_AllAreSPAM",xmlnode_get_data(xmlnode_get_tag(jtin->config,"smtp/allmessagesarespam")));


   xmlnode_put_attrib(loJID,"J2S_RTMode","0");
   xmlnode_put_attrib(loJID,"J2S_RTName",lcJID);
   xmlnode_put_attrib(loJID,"J2S_RTAddr",lcJID);

   loSubj=xmlnode_get_tag(jtin->config,"jabber/subject");
   if ( loSubj!=NULL)
      {
      xmlnode_put_attrib(loJID,"J2S_SRMode",xmlnode_get_attrib(loSubj,"replace"));
      xmlnode_put_attrib(loJID,"J2S_SRSeparator",xmlnode_get_attrib(loSubj,"separator"));
      xmlnode_put_attrib(loJID,"J2S_SRText",xmlnode_get_data(loSubj));
      }


   loSubj=xmlnode_get_tag(jtin->config,"smtp/subject");
   if ( loSubj!=NULL)
      {
      xmlnode_put_attrib(loJID,"S2J_SRMode",xmlnode_get_attrib(loSubj,"replace"));
      xmlnode_put_attrib(loJID,"S2J_SRSeparator",xmlnode_get_attrib(loSubj,"separator"));
      xmlnode_put_attrib(loJID,"S2J_SRText",xmlnode_get_data(loSubj));
      }
   
   xmlnode_put_attrib(loJID,"default","1"); // flag of default item
   return loJID;
   }

xmlnode smtp_roster_get_item( char *lcJID, int liDefault)
   {
   xmlnode loJID=NULL,loFile;
   int liFound=0;
   char *lcLetter;
   pool p;

   if (j_strlen(lcJID)==0)
      return (xmlnode) NULL;

   p=pool_new();
   smtp_PoolsReg(1801, p);

 
   lcLetter = (char*)pmalloc_x(p, 4,'\0');
   lcLetter[0]=lcJID[0];
   if (lcJID[0]<0)
      toEscape(lcLetter,(void *)lcLetter,"()<>,;:\"/[]?");

   loFile=xmlnode_get_tag(jtin->roster,spools(p,"file?type=",lcLetter,p));

   if (loFile!=NULL)
      if ((loFile=xmlnode_get_tag(jtin->roster_files,spools(p,"file?type=",lcLetter,p)))!=NULL)
         {
         if ((loJID=xmlnode_get_tag(loFile,spools(p,"item?jid=",lcJID,p)))!=NULL)
            {
            liFound=1;
            if (j_strlen(xmlnode_get_attrib(loJID,"J2S_RTMode"))==0)
               {
               xmlnode_put_attrib(loJID,"J2S_RTMode","0");
               xmlnode_put_attrib(loJID,"J2S_RTName",lcJID);
               xmlnode_put_attrib(loJID,"J2S_RTAddr",lcJID);
               }
            }
         }

   if (liFound==0 && liDefault!=0) // if not found and must return default item
      loJID=smtp_roster_get_defaultitem(lcJID);


   pool_free(p);
   return loJID;
   }


void smtp_roster_set_item(char *lcJID, xmlnode loJID)
   {
   xmlnode loFile,loJIDOld,loFileM,loFileS;
   char *lcFile, *lcLetter;
   pool p;

   int liSaveM=0;
   if (j_strlen(lcJID)==0)
      return ;

   p=pool_new();
   smtp_PoolsReg(1802, p);

   lcLetter = (char*)pmalloc_x(p, 4,'\0');
   lcLetter[0]=lcJID[0];
   if (lcJID[0]<0)
      toEscape(lcLetter,(void *)lcLetter,"()<>,;:\"/[]?");

   xmlnode_hide_attrib(loJID,"default");

   if ((loFileM=xmlnode_get_tag(jtin->roster,spools(p,"file?type=",lcLetter,p)))==NULL)
      {
      // zznam pro dan psmeno neexistuje
      lcFile = (char*)pmalloco(p, 254);
      lcFile[-1] = '\0';
      lcFile=spools(p,jtin->roster_folder,"/roster_",lcLetter,".xml",p);

      xmlnode_put_attrib((loFileM=xmlnode_insert_tag(jtin->roster,"file")),"type",lcLetter);
      xmlnode_insert_cdata(loFileM,lcFile,-1);
      liSaveM=1;
      }
   else
      lcFile=xmlnode_get_data(loFileM);

   if ((loFile=xmlnode_get_tag(jtin->roster_files,spools(p,"file?type=",lcLetter,p)))==NULL)
      {
      // zznam pro dan psmeno neexistuje
      xmlnode_put_attrib(loFile=xmlnode_insert_tag(jtin->roster_files,"file"),"type",lcLetter);
      }


   if ((loJIDOld=xmlnode_get_tag(loFile,spools(p,"item?jid=",lcJID,p)))==NULL)
      {
      // new item
      xmlnode_insert_node(loFile,loJID);
      }
   else
      {
      // replace item
      }

// vytvo kopii xmlnode a tu potom ulo...
   loFileS=xmlnode_dup(loFile);
   if (xmlnode2file(lcFile,loFileS)!=1)
      {
      log_alert(SMTP_ZONE,"ROSTER - Cannot save roster-letter file %s.",lcFile);
      smtp_SendInfoToAdmin(spools(p,"ROSTER - Cannot save roster-letter file ",lcFile,".",p ),SMTP_SITA_P);
      }
   xmlnode_free(loFileS);


   if (liSaveM==1)
      {
      loFileS=xmlnode_dup(jtin->roster);
      if ( xmlnode2file(jtin->roster_file,loFileS)!=1)
         {
         log_alert(SMTP_ZONE,"ROSTER - Cannot save main roster file %s.",jtin->roster_file);
         smtp_SendInfoToAdmin(spools(p,"ROSTER - Cannot save main roster file ",jtin->roster_file,".",p ),SMTP_SITA_P);
         }
      xmlnode_free(loFileS);
      }
   
   pool_free(p);
   }



void smtp_roster_set_itemEx(char *lcJID, xmlnode loJID)
   {
   xmlnode loFile,loJIDOld,loFileM,loFileS;
   char *lcFile, *lcLetter;
   pool p;

   int liSaveM=0;
   if (j_strlen(lcJID)==0)
      return ;

   p=pool_new();
   smtp_PoolsReg(1802, p);

   lcLetter = (char*)pmalloc_x(p, 4,'\0');
   lcLetter[0]=lcJID[0];
   if (lcJID[0]<0)
      toEscape(lcLetter,(void *)lcLetter,"()<>,;:\"/[]?");

   xmlnode_hide_attrib(loJID,"default");

   if ((loFileM=xmlnode_get_tag(jtin->roster,spools(p,"file?type=",lcLetter,p)))==NULL)
      {
      // zznam pro dan psmeno neexistuje
      lcFile = (char*)pmalloco(p, 254);
      lcFile[-1] = '\0';
      lcFile=spools(p,jtin->roster_folder,"/roster_",lcLetter,".xml",p);

      xmlnode_put_attrib((loFileM=xmlnode_insert_tag(jtin->roster,"file")),"type",lcLetter);
      xmlnode_insert_cdata(loFileM,lcFile,-1);
      liSaveM=1;
      }
   else
      lcFile=xmlnode_get_data(loFileM);

   if ((loFile=xmlnode_get_tag(jtin->roster_files,spools(p,"file?type=",lcLetter,p)))==NULL)
      {
      // zznam pro dan psmeno neexistuje
      xmlnode_put_attrib(loFile=xmlnode_insert_tag(jtin->roster_files,"file"),"type",lcLetter);
      }


   if ((loJIDOld=xmlnode_get_tag(loFile,spools(p,"item?jid=",lcJID,p)))==NULL)
      {
      // new item
      xmlnode_insert_node(loFile,loJID);
      }
   else
      {
      xmlnode_hide(loJIDOld);
      xmlnode_insert_node(loFile,loJID);
      // replace item
      }

// vytvo kopii xmlnode a tu potom ulo...
   loFileS=xmlnode_dup(loFile);
   if (xmlnode2file(lcFile,loFileS)!=1)
      {
      log_alert(SMTP_ZONE,"ROSTER - Cannot save roster-letter file %s.",lcFile);
      smtp_SendInfoToAdmin(spools(p,"ROSTER - Cannot save roster-letter file ",lcFile,".",p ),SMTP_SITA_P);
      }
   xmlnode_free(loFileS);


   if (liSaveM==1)
      {
      loFileS=xmlnode_dup(jtin->roster);
      if ( xmlnode2file(jtin->roster_file,loFileS)!=1)
         {
         log_alert(SMTP_ZONE,"ROSTER - Cannot save main roster file %s.",jtin->roster_file);
         smtp_SendInfoToAdmin(spools(p,"ROSTER - Cannot save main roster file ",jtin->roster_file,".",p ),SMTP_SITA_P);
         }
      xmlnode_free(loFileS);
      }
   
   pool_free(p);
   }

void smtp_roster_remove_item(char *lcJID)
   {
   xmlnode loFile,loJIDOld,loFileM,loFileS;
   char *lcFile, *lcLetter;
   pool p;


   if (j_strlen(lcJID)==0)
      return;

   p=pool_new();
   smtp_PoolsReg(1803, p);

   lcLetter = (char*)pmalloc_x(p, 4,'\0');
   lcLetter[0]=lcJID[0];
   if (lcJID[0]<0)
      toEscape(lcLetter,(void *)lcLetter,"()<>,;:\"/[]?");

   if ((loFileM=xmlnode_get_tag(jtin->roster,spools(p,"file?type=",lcLetter,p)))!=NULL)
      // zznam pro dan psmeno existuje
      {
      lcFile=xmlnode_get_data(loFileM);
      if ((loFile=xmlnode_get_tag(jtin->roster_files,spools(p,"file?type=",lcLetter,p)))!=NULL)
         {
         // zznam pro dan psmeno existuje
         if ((loJIDOld=xmlnode_get_tag(loFile,spools(p,"item?jid=",lcJID,p)))!=NULL)
            {
            // item exist
            xmlnode_hide(loJIDOld);
            loFileS=xmlnode_dup(loFile);
            if (xmlnode2file(lcFile,loFileS)!=1)
               {
               log_alert(SMTP_ZONE,"ROSTER - Cannot save roster-letter file %s.",lcFile);
               smtp_SendInfoToAdmin(spools(p,"ROSTER - Cannot save roster-letter file ",lcFile,".",p ),SMTP_SITA_P);
               }
            xmlnode_free(loFileS);
            }
         }
      }

   pool_free(p);
   }


//--------------------------------------------------
void smtp_RIGetInfo(smtp_riinfo loInfo)
   {
   if ((loInfo->iFlag&SMTP_RI_READED)==SMTP_RI_READED)
      return;

   xmlnode loFile,loJID;
   smtp_cjid loItem;

   if ((loInfo->iFlag&SMTP_CLI_USERS)==SMTP_CLI_USERS)
      loInfo->iAccounts=jtin->Stats->_CoreAccounts;

   if ((loInfo->iFlag&SMTP_CLI_USERSVIP)==SMTP_CLI_USERSVIP)
      loInfo->iAccountsVIP=0;

   if ((loInfo->iFlag&SMTP_CLI_USERSO)==SMTP_CLI_USERSO)
      loInfo->iOnlineAccounts=0;


   for (loFile = xmlnode_get_tag(jtin->roster_files,"file"); loFile != NULL; loFile = xmlnode_get_nextsibling(loFile))
       {
       if (loFile->type!=NTYPE_TAG)
           continue;

       // walk all jid in file
       for (loJID = xmlnode_get_tag(loFile,"item"); loJID != NULL; loJID = xmlnode_get_nextsibling(loJID))
           {
           if ((loInfo->iFlag&SMTP_RI_RACCOUNTS)==SMTP_RI_RACCOUNTS)
              loInfo->iAccounts++;

           if ((loInfo->iFlag&SMTP_RI_ACCOUNTSVIP)==SMTP_RI_ACCOUNTSVIP)
              if (j_atoi(xmlnode_get_attrib(loJID,"paid"),0)!=0)
                  loInfo->iAccountsVIP++;

           if ((loInfo->iFlag&SMTP_RI_ACCOUNTSO)==SMTP_RI_ACCOUNTSO)
              if ((loItem=smtp_cjidGet(xmlnode_get_attrib(loJID,"jid")))!=NULL && loItem->iLogin==1)
                 loInfo->iOnlineAccounts++;
           }
       }

   return;
   }
//--------------------------------------------------

smtp_cjid smtp_cjidNew(xmlnode loNode,char *lcJID)
   {
   smtp_cjid item;
   pool p;

   if (loNode==NULL && lcJID==NULL)
      return NULL;

   if (loNode==NULL)
      {
      item=pmalloco(p=pool_new(), sizeof(_smtp_cjid));
      smtp_PoolsReg(40, p);
      smtp_PoolsSettmp(p, 0);

      item->p=p;
      item->item=xmlnode_new_tag_pool(p,"item");
      item->cJID=pstrdup(p,lcJID);
      xmlnode_put_attrib(item->item,"jid",lcJID);
      }
   else
      {
      item=pmalloco(p=xmlnode_pool(loNode), sizeof(_smtp_cjid));
      item->p=p;
      item->item=loNode;
      item->cJID=xmlnode_get_attrib(loNode,"jid");
      }

   item->offitem=xmlnode_new_tag_pool(p,"item");
   item->last=NULL;
   item->iLogin=0;

   return item;
   }


smtp_cjid smtp_cjidGet(char *lcJID)
   {
   smtp_cjid next=jtin->ContactList,b=NULL;
   while(next != NULL)
        {
        if (j_strcmp(next->cJID,lcJID)==0)
           {
           b=next;
           break;
           }

        if (next->next != NULL)
           next = next->next;
        else
           break;

        }
   return b;
   }


smtp_cjid smtp_cjidAppend(smtp_cjid b)
   {
   smtp_cjid root=jtin->ContactList,last;
   if (b == NULL)
      return NULL;

   if (root == NULL)
      {
      jtin->ContactList=b;
      return b;
      }

   if ((last=root->last)==NULL) // save Last item
      root->last=root->next=b;
   else
      {
      last->next=b;
      root->last=b;
      }

   return b;
   }


void smtp_cjidDel(char *lcJID)
   {
   smtp_cjid root=jtin->ContactList,next=jtin->ContactList,prev;
   if (lcJID==NULL)
       return;

   while(next != NULL)
        {
        if (j_strcmp(next->cJID,lcJID)==0)
           {
           if (next==root && next->next==NULL) // root item
              jtin->ContactList=NULL; // clear it
           else if (next==root && next->next!=NULL) // check to first item
              {
              jtin->ContactList=next->next;
              jtin->ContactList->last=next->last;
              }
           else if (root->last==next) // check to last item
              {
              root->last=prev; // copy last item to rootlast
              prev->next=NULL; // clear next item
              }
           else
              prev->next=next->next;  // change next item

           smtp_PoolsSettmp(next->p, 1);
           pool_free(next->p); // free item
           break;
           }

        prev=next;
        if (next->next != NULL)
           next = next->next;
        else
           break;
        }
   return ;
   }


void smtp_cjidGetInfo(smtp_clinfo loInfo)
   {
   smtp_cjid next=jtin->ContactList;
   xmlnode loJID,loTo;

   if ((loInfo->iFlag&SMTP_CLI_READED)==SMTP_CLI_READED)
      return;

   if ((loInfo->iFlag&SMTP_CLI_USERS)==SMTP_CLI_USERS)
      loInfo->iUsers=0;

   if ((loInfo->iFlag&SMTP_CLI_USERSVIP)==SMTP_CLI_USERSVIP)
      loInfo->iUsersVIP=0;

   if ((loInfo->iFlag&SMTP_CLI_USERSO)==SMTP_CLI_USERSO)
      loInfo->iOnlineUsers=0;

   if ((loInfo->iFlag&SMTP_CLI_CONTACTS)==SMTP_CLI_CONTACTS)
      loInfo->iContacts=jtin->Stats->_CoreContacts;

   if ((loInfo->iFlag&SMTP_CLI_CONTACTSO)==SMTP_CLI_CONTACTSO)
      loInfo->iOnlineContacts=jtin->Stats->_CoreContactsOnline;

   if ((loInfo->iFlag&SMTP_CLI_MEMORY)==SMTP_CLI_MEMORY)
      loInfo->iMemory=0;


   while(next != NULL)
        {
        if ((loInfo->iFlag&SMTP_CLI_MEMORY)==SMTP_CLI_MEMORY)
           loInfo->iMemory+=pool_size(next->p);

        if ((loInfo->iFlag&SMTP_CLI_USERS)==SMTP_CLI_USERS)
           loInfo->iUsers++;

        if ((loInfo->iFlag&SMTP_CLI_USERSO)==SMTP_CLI_USERSO && next->iLogin==1)
           loInfo->iOnlineUsers++;

        if ((loInfo->iFlag&SMTP_CLI_USERSVIP)==SMTP_CLI_USERSVIP)
           {
           // get VIP flag from roster
           loJID=smtp_roster_get_item(xmlnode_get_attrib(next->item,"jid") ,0);
           if (loJID!=NULL && j_atoi(xmlnode_get_attrib(loJID,"paid"),0)!=0)
              loInfo->iUsersVIP++;
           }

        if ((loInfo->iFlag&SMTP_CLI_RCONTACTS)==SMTP_CLI_RCONTACTS)
           {
           for (loTo = xmlnode_get_tag(next->item,"to"); loTo != NULL; loTo = xmlnode_get_nextsibling(loTo))
               {
               if (loTo->type!=NTYPE_TAG)
                   continue;

               loInfo->iContacts++;
               }
           }

        if (next->next != NULL)
           next = next->next;
        else
           break;

        }
   loInfo->iFlag=loInfo->iFlag|SMTP_CLI_READED;
   return;
   }


int smtp_online_add_item(char *lcFrom, char *lcTo)
   {
   xmlnode loTo,loFileS;
   smtp_cjid loItem;
   int liCount=0,liAdd=0;
   char *lcFile;
   pool p=pool_new();
   smtp_PoolsReg(1804, p);

   if ((loItem=smtp_cjidGet(lcFrom))==NULL) // find item in list
      smtp_cjidAppend(loItem=smtp_cjidNew(NULL,lcFrom)); // not exist add it
  

   // check to item
   if (j_strlen(lcTo)>0)
      {
      if ((loTo=xmlnode_get_tag(loItem->item,spools(p,"to=",lcTo,p)))==NULL)
         {
         // record is not exist, create it
         // check if exist subitem in offline list
         if ((loTo=xmlnode_get_tag(loItem->offitem,spools(p,"to=",lcTo,p)))==NULL)
            xmlnode_insert_cdata(loTo=xmlnode_insert_tag(loItem->item,"to"),lcTo,-1);
         else
            {
            smtp_xmlnode_move_node(loTo, loItem->offitem, loItem->item);
            }

         liAdd=1;
         }
      liCount=1;
      }

   if (j_strlen(lcTo)==0 && loItem->iLogin==0)
      {
      loItem->iLogin=1;
      for (loTo = xmlnode_get_tag(loItem->item,"to"); loTo != NULL; loTo = xmlnode_get_nextsibling(loTo))
          {
          if (loTo->type!=NTYPE_TAG)
             continue;

          liCount++;
         }
      }

   if (liAdd>0)
      {
      lcFile=spools(p,jtin->roster_folder,"/",lcFrom,".xml",p);
      loFileS=xmlnode_dup(loItem->item);
      if (xmlnode2file(lcFile,loFileS)!=1)
         {
         log_alert(SMTP_ZONE,"ROSTER contacts - Cannot save roster-contacts file %s.",lcFrom);
         smtp_SendInfoToAdmin(spools(p,"ROSTER contacts - Cannot save contacts-letter file ",lcFrom,".",p ),SMTP_SITA_P);
         }
      xmlnode_free(loFileS);
      }

   pool_free(p);

   return liCount;
   }

int smtp_online_remove_item(char *lcFrom, char *lcTo)
   {
   xmlnode loTo,loFileS;
   smtp_cjid loItem;
   int liCount=0;
   char *lcFile;
   pool p;

   if ((loItem=smtp_cjidGet(lcFrom))==NULL) // find item in list
      return 0;      // record is not exist

   p=pool_new();
   smtp_PoolsReg(1805,p);

   lcFile=spools(p,jtin->roster_folder,"/",lcFrom,".xml",p);

   if (j_strlen(lcTo)>0) // remove sub item
      {
      // check to item
      liCount=1;
      if ((loTo=xmlnode_get_tag(loItem->item,spools(p,"to=",lcTo,p)))!=NULL)
         {
         smtp_xmlnode_move_node(loTo, loItem->item, loItem->offitem);
         }
      }
   else
      {
      loItem->iLogin=0;
      // move subitems to offline, walk all item 
      for (loTo = xmlnode_get_tag(loItem->item,"to"); loTo != NULL; loTo = xmlnode_get_nextsibling(loTo))
          {
          if (loTo->type!=NTYPE_TAG)
      	    continue;

          liCount++;
          }
      }


   if (j_strlen(lcTo)>0 )
      {
      loFileS=xmlnode_dup(loItem->item);
      if (xmlnode2file(lcFile,loFileS)!=1)
         {
         log_alert(SMTP_ZONE,"ROSTER contacts - Cannot save roster-contacts file %s.",lcFrom);
         smtp_SendInfoToAdmin(spools(p,"ROSTER contacts - Cannot save contacts-letter file ",lcFrom,".",p ),SMTP_SITA_P);
         }
      xmlnode_free(loFileS);
      }

   pool_free(p);
   return liCount;
   }

int smtp_online_is(char *lcFrom)
   {
   smtp_cjid loItem;
   if ((loItem=smtp_cjidGet(lcFrom))==NULL) // find item in list
      return 0;

   return loItem->iLogin;
   }


int RM_LoadData(pool p)
   {
   int liErr,lii;
   spool lcSP;
   char *lcFile;
   xmlnode loFile,loRF,cur;
   pool px;
   struct dirent   *dirp;
   DIR      *dp;

   px=pool_new();
   smtp_PoolsReg(1810, p);

   // get roster
   if ((jtin->roster_file=xmlnode_get_tag_data(jtin->config,"core/roster"))==NULL)
      jtin->roster_file=pstrdup(p,SMTP_ROSTER_FILE);

   jtin->roster_folder=smtp_GetFolderFromFile((char*)pstrdup(p,jtin->roster_file));
   liErr=smtp_CreateFolder(jtin->roster_folder);
   if (liErr!=0)
      { // file not exist or any other bug
      log_error(SMTP_ZONE,"Transport cannot create folder (%s) for roster file.",jtin->roster_folder);
      return -1;
      }

   liErr=smtp_CreateFolder(spools(p,jtin->roster_folder,"/backup",p));
   if (liErr!=0)
      { // file not exist or any other bug
      log_error(SMTP_ZONE,"Transport cannot create folder (%s) for roster file.",spools(px,jtin->roster_folder,"/backup",px));
      return -1;
      }


   jtin->roster_files=xmlnode_new_tag("smtp");
   smtp_PoolsReg(2021, xmlnode_pool(jtin->roster_files));
   smtp_PoolsSettmp(xmlnode_pool(jtin->roster_files), 0);

   xmlnode_put_attrib(jtin->roster_files,"xmlns","jabber:rosterfiles:smtp");

   if ((jtin->roster=xmlnode_file(jtin->roster_file))==NULL)
      { // file not exist or any other bug
      jtin->roster=xmlnode_new_tag("smtp");
      xmlnode_put_attrib(jtin->roster,"xmlns","jabber:roster:smtp");
      log_warn(SMTP_ZONE,"Transport cannot load roster file (%s)", jtin->roster_file);
      smtp_SendInfoToAdmin(spools(px, "Transport cannot load roster file (",jtin->roster_file,").",px),SMTP_SITA_M );
      }  
   else
      {
      // build file list from roster.xml
      lii=0;
      lcSP=spool_new(px);
      for (loFile = xmlnode_get_firstchild(jtin->roster); loFile != NULL; loFile = xmlnode_get_nextsibling(loFile))
          {
          if (loFile->type!=NTYPE_TAG)
              continue;

          lcFile=xmlnode_get_data(loFile);
          if ((loRF=xmlnode_file(lcFile))==NULL)
             {
             log_warn(SMTP_ZONE,"Transport cannot read roster file %s",lcFile);
             spooler(lcSP, "Transport cannot read roster file ",lcFile,".\r\n",lcSP);
             lii++;
             continue;
             }

          xmlnode_insert_node(jtin->roster_files,loRF);
          xmlnode_free(loRF);
          }

      if (lii>0)
          smtp_SendInfoToAdmin(spool_print(lcSP),SMTP_SITA_M );

      smtp_riinfo loInfo= pmalloco(px, sizeof(_smtp_riinfo));
      loInfo->iFlag=SMTP_RI_RACCOUNTS;
      smtp_RIGetInfo(loInfo);
      jtin->Stats->_CoreAccounts=loInfo->iAccounts;
      }

   smtp_PoolsReg(2020, xmlnode_pool(jtin->roster));
   smtp_PoolsSettmp(xmlnode_pool(jtin->roster), 0);


   // Read contacts
   if ((dp = opendir(jtin->roster_folder))!=NULL)
      {
      lii=0;
      lcSP=spool_new(px);
      while ( (dirp = readdir((DIR *)dp)) != NULL)
            {
            if (strcmp(dirp->d_name, ".") == 0  ||
                strcmp(dirp->d_name, "..") == 0 ||
                strcmp(dirp->d_name, "backup") == 0 ||
                strchr(dirp->d_name,'@')==NULL)
               continue;      // ignore dot and dot-dot and not contacts list

            // try read file with contacts
            // if reading failed, then copy it to backup folder
            //  and send info to admin

            lcFile=spools(px,jtin->roster_folder,"/",dirp->d_name,px);
            if ((cur=xmlnode_file(lcFile))==NULL)
               {
               log_warn(SMTP_ZONE,"Transport cannot load contact file (%s)", lcFile);
               spooler(lcSP, "Transport cannot load contact file (",lcFile,").\r\n",lcSP);
               rename(lcFile,spools(px,jtin->roster_folder,"/backup/",dirp->d_name,px));
               lii++;
               continue;
               }

            smtp_PoolsReg(40, xmlnode_pool(cur));
            smtp_PoolsSettmp(xmlnode_pool(cur), 0);

            smtp_cjidAppend(smtp_cjidNew(cur,NULL));
            }

      if (lii>0)
          smtp_SendInfoToAdmin(spool_print(lcSP),SMTP_SITA_M );

      closedir((DIR *)dp);

      smtp_clinfo loInfo= pmalloco(px, sizeof(_smtp_clinfo));
      loInfo->iFlag=SMTP_CLI_RCONTACTS;
      smtp_cjidGetInfo(loInfo);
      jtin->Stats->_CoreContacts=loInfo->iContacts;
      }


   pool_free(px);
   return 0;
   }

